<template>
	<div class="form-group">
		<input ref="inputRef" type="text" :class="thisClass" :disabled="props.disabled" :required="props.required"
			:placeholder="props.placeholder" :autocomplete="props.autocomplete" :id="props.id" />
	</div>
</template>

<script setup lang="ts">
import { computed, watch } from "vue";
import {
	type CurrencyInputOptions,
	useCurrencyInput,
	CurrencyDisplay,
	type NumberRange,
} from "vue-currency-input";

// PROPS
const props = defineProps({
	modelValue: { type: Number, default: NaN },
	options: { type: Object as () => CurrencyInputOptions, default: {} },
	class: { type: String, default: "" },
	disabled: { type: Boolean, default: false },
	required: { type: Boolean, default: true },
	placeholder: { type: String, default: "" },
	autocomplete: { type: String, default: "off" },
	id: { type: String, default: "inputCurrency" }
});

const defaultOptions = {
	currency: "ARS",
	hideGroupingSeparatorOnFocus: false,
	currencyDisplay: CurrencyDisplay.hidden,
	precision: 2,
	valueRange: {
		min: 0
	} as NumberRange
} as CurrencyInputOptions;

const { inputRef, setValue } = useCurrencyInput({ ...defaultOptions, ...props.options });

// #region COMPUTED
const thisClass = computed(() => {
	return props.class.split(" ");
});
// #endregion

watch(
	() => props.modelValue,
	(value: number) => {
		setValue(value != null ? value : null);
	}
);
</script>
